package post_number;

import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.camunda.bpm.client.ExternalTaskClient;
import java.io.IOException;
import java.util.*;

public class App {

    public static void main(String... args) throws IOException{
        // bootstrap the client
        ExternalTaskClient client = ExternalTaskClient.create()
                .baseUrl("http://localhost:8080/engine-rest")
                .build();

        // subscribe to the topic
        client.subscribe("postNumberTopic")
                .lockDuration(1000)
                .handler((externalTask, externalTaskService) -> {
                    /*
                      Initialize variables from the camunda workflow.
                      number: The random number generated by the previous external task.
                      token: The token for Slack api authentication.
                      location: The base url for Slack api.
                      route: The specific endpoint for Slack api. In this case it is /post.message.
                      slack_channel: The Slack channel you want to post to.
                     */
                    int number = externalTask.getVariable("number");
                    String token = externalTask.getVariable("token");
                    String location = externalTask.getVariable("location");
                    String route = externalTask.getVariable("route");
                    String slack_channel = externalTask.getVariable("slack_channel");
                    String username = System.getProperty("user.name");
                    // Using CloseableHttpClient to do a post request.
                    CloseableHttpClient httpClient = HttpClients.createDefault();
                    HttpPost httpPost = new HttpPost(location + "/" + route);
                    List<NameValuePair> params = new ArrayList<>();
                    // Setting header
                    httpPost.setHeader("Authorization", "Bearer " + token);
                    // Setting request body
                    params.add(new BasicNameValuePair("text",
                            String.format("[%s] Workflow received random number - %d - that is large enough", username, number)));
                    params.add(new BasicNameValuePair("channel", slack_channel));

                    try {
                        httpPost.setEntity(new UrlEncodedFormEntity(params));
                        CloseableHttpResponse response = httpClient.execute(httpPost);
                        if (response.getStatusLine().getStatusCode() != 200) System.out.println("Unable to post to slack.");
                        else System.out.println("Successfully posted to Slack.");
                        response.close();
                        httpClient.close();
                        externalTaskService.complete(externalTask);
                    } catch (IOException e) {
                        throw new RuntimeException(e);
                    }
                }).open();
    }
}